Subject: Re: [BUG] next-20081216 - WARNING: at kernel/smp.c:333 smp_call_function_mask

From: Ingo Molnar <[email-masked]>
Date: Sat, 27 Dec 2008 10:50:19 +0100

* David Howells <[email-masked]> wrote:

> Sam Ravnborg <[email-masked]> wrote:
> 
> > I recall David Howells had a similar issue with the bootparamter patch set.
> > The workaround he used was to add a barrier(); call in the weak function
> > to avoid the inline.
> 
> Yes I did.  Rusty's solution was just to move the default weak functions into
> different files.
> 
> Attempting to use the noinline attribute does not work.
> 
> Of course, you could just stick the functions into lib/ in separate .c 
> files and dispense with the weak attribute altogether.

the weak functions should be close to where the code that uses them is - 
not somewhere separate (where no-one will really be aware of their 
existence). So either we find a way to avoid such repeat bugs in the 
future, or we do away with weak functions altogether and go back to 
stone-age #ifdefs ;-)

I think we should get a Sparse check that detects empty void __weak 
functions?

	Ingo